#if !defined parse_usenet_h
#define parse_usenet_h
#include <boost\property_tree\ptree.hpp>
#include <string>
#include <fstream>

template<class Ptree>
void ReadGroupsList(std::string &file, Ptree &pt)
{
	std::basic_ifstream<typename Ptree::char_type> listFile(file.c_str());
	std::basic_string<typename Ptree::char_type> key;
	std::basic_string<typename Ptree::char_type> data;
	size_t sItr;

	if (!listFile)
	{
		throw ("can not open file");
	}
	while (!listFile.eof())
	{
		std::getline(listFile, data);
		sItr = data.find(" ");
		key = data.substr(0, sItr);
		data.erase(0, sItr+1);
        pt.push_back(std::make_pair(key.c_str(), data.c_str()));
	}
}


template<class Ptree>
void WriteGroupsList(std::string &file, Ptree &pt)
{
    typedef typename Ptree::char_type tch;
	std::basic_ofstream<typename Ptree::char_type> listFile(file.c_str());
	if (!listFile)
	{
		throw ("can not open file");
	}
    for (typename Ptree::iterator it = pt.begin(), end = pt.end(); it != end; ++it)
    {
        listFile << it->first; 
        listFile << tch(' ');
        listFile << it->second.template get_own<std::basic_string<tch> >();
        listFile << tch('\n');
    }
}
#endif
